//**************************************************************************************************
//*  FRIDA: fast reliable interactive data analysis                         
//*  (C) Joachim Wuttke 1990-, v2(C++) 2001-                                
//*  http://www.mesen-und-deuten.de/frida                                   
//**************************************************************************************************

//! \file  ptr.hpp
//! \brief pointer forward declarations POlo, PNode, and so on (.h file only)

#include <boost/shared_ptr.hpp>

#define PCAST boost::dynamic_pointer_cast
#define SPTR boost::shared_ptr
#define DEF_PTR( C, P, R ) \
    typedef boost::shared_ptr<      class C> P;  \
    typedef boost::shared_ptr<const class C> R
    
DEF_PTR( COlo,       POlo,       ROlo );
DEF_PTR( COlc,       POlc,       ROlc );
DEF_PTR( COld,       POld,       ROld );
DEF_PTR( CSlice,     PSlice,     RSlice );
DEF_PTR( CSpec,      PSpec,      RSpec );
DEF_PTR( CCurve,     PCurve,     RCurve );
DEF_PTR( CObj,       PObj,       RObj );
DEF_PTR( CObjNum,    PObjNum,    RObjNum );
DEF_PTR( CObjInt,    PObjInt,    RObjInt );
DEF_PTR( CObjDbl,    PObjDbl,    RObjDbl );
DEF_PTR( CObjEnu,    PObjEnu,    RObjEnu );
DEF_PTR( CObjStr,    PObjStr,    RObjStr );
DEF_PTR( CObjVec,    PObjVec,    RObjVec );
DEF_PTR( CObjVecNum, PObjVecNum, RObjVecNum );
DEF_PTR( CObjVecInt, PObjVecInt, RObjVecInt );
DEF_PTR( CObjVecDbl, PObjVecDbl, RObjVecDbl );
DEF_PTR( CObjVecEnu, PObjVecEnu, RObjVecEnu );
DEF_PTR( CNode,      PNode,      RNode );
DEF_PTR( CNodeList,  PNodeList,  RNodeList );
DEF_PTR( CVar,       PVar,       RVar );
DEF_PTR( CRef,       PRef,       RRef );
