//**************************************************************************************************
//* libtrivia: various little routines for C++
//* file_ops: file operations
//* (C) Joachim Wuttke 2001, 2012-
//* http://apps.jcns.fz-juelich.de
//**************************************************************************************************

namespace triv {

    using namespace std;

    // Improved libc calls:
    void system( string cmd, bool debug=false );
    string system_read( string cmd, bool debug=false );

    // File names, globbing:
    bool file_exists( const string& fname );
    void fname_divide( const string& fname, string *fdir, string *fshort, string *fext);
    void glob_file_list( const string& pattern, const string& extension, vector<string> *fnames );
    string wordexp_unique( const string& s );
    string next_tmp_file( const string& path_format );

    // File read:
    bool freadln( FILE *fd, string *s );
}
